#ifndef PORYGONLANG_LEXER_HPP
#define PORYGONLANG_LEXER_HPP
#include <string>
#include <vector>
#include "Token.hpp"

using namespace std;

class Lexer {
    string Script;
#ifdef TESTS_BUILD
public:
#endif
    unsigned int Position;
    char Peek();
    char Next();
    IToken* LexNext(char c);
    IToken* LexNumber(char c);
    IToken *LexIdentifierOrKeyword(char c);
public:
    vector<IToken*> Lex();
    explicit Lexer(string script);
};


#endif //PORYGONLANG_LEXER_HPP
